
--[[
	Radar HUD Script
	by Georg Schmid
	(c) 2006
	gspschmid@gmail.com
	"GcDesign" <-> FacePunchForums

	With modifications (Misc. Ents support, 'Hazard Mode')
	by Splambob, 2007
	the_guy_with_pie@hotmail.com
]]


--RADAR

local radar = {}

--Default values
radar.w = 256
radar.h = 256
radar.x = ScrW()-radar.w-16
radar.y = 16
radar.alphascale = 0.6
radar.bgcolor = Color(0,200,0,255)
radar.fgcolor = Color(0,255,0,255)
radar.dangercolour = Color(220,0,0,255)
radar.dangerblipcolour = Color(255,255,0,255)
radar.screendetail = 64 -- Ooh, purty.
radar.screenrotation = 0
radar.hazardmode = true 	-- If the radar finds any hazardous ents in its radius, should it bitch about it?

radar.radius = 5000

radar.player_show = true
radar.player_color = Color(30,255,30,255)
surface.CreateFont("Arial",64,400,false,false,"RadarPlayerLabel")
radar.player_fontcolor = Color(255,255,255,255)
radar.player_showname = true
radar.player_showhealth = true
radar.player_showarmor = false --TO DO
radar.player_showammo = true


radar.scanfor = {"player", "blastfungus", "rpg_missile", "crossbow_bolt", "npc_", "sent_", "prop_vehicle_"}		-- What should the radar look for?  Accepts partial names.
radar.dangerous = {"sent_nuke_missile", "sent_nuke_detpack"}		-- What should the radar consider extremely hazardous? ("Hazard Mode")  Only accepts full names.

-- The danger table relies on the scan table, make sure your dangerous ent is in both tables.


------------------------------------------------------------------
-- Don't edit under here unless you're the trigonometry GOD. D: --
------------------------------------------------------------------


radar.bgcolorbak = radar.bgcolor
radar.fgcolorbak = radar.fgcolor
radar.player_colorbak = radar.player_color


local color_ascale = function(col,scale) return Color(col.r,col.g,col.b,col.a*scale) end

-- Without further ado, let's rock.



function gspHUD_DrawRadar ()

	local ETable = {}
	local PulseRadar = false

	local lpl = LocalPlayer()
	if ( not lpl:Alive() ) then return end
	
	
	if ( radar.player_show ) then
	
	--draw.RoundedBox( radar.w/2, radar.x, radar.y, radar.w, radar.h, radar.bgcolor ) --Looks like shit
	local vertices = {}
	for i=1,radar.screendetail do
		local shift = math.fmod(CurTime()*radar.screenrotation,360)
		local sizescale = 1 --+ math.sin(CurTime())/10
		local tab = {}
		tab.x = radar.x+radar.w/2 + math.cos(math.Deg2Rad((360/radar.screendetail)*i+shift)) * radar.w/2 * sizescale
		tab.y = radar.y+radar.h/2 + math.sin(math.Deg2Rad((360/radar.screendetail)*i+shift)) * radar.h/2 * sizescale
		tab.u = 0
		tab.v = 0
		table.insert(vertices,tab)
	end
	surface.SetTexture(surface.GetTextureID("vgui/white"))
	surface.SetDrawColor(radar.bgcolor.r,radar.bgcolor.g,radar.bgcolor.b,radar.bgcolor.a*radar.alphascale)
	surface.DrawPoly(vertices)
    draw.RoundedBox( 0, radar.x+radar.w/2, radar.y, 1, radar.h, color_ascale(radar.fgcolor,radar.alphascale) )
	draw.RoundedBox( 0, radar.x, radar.y+radar.h/2, radar.w, 1, color_ascale(radar.fgcolor,radar.alphascale) )
	
	local players = {}

	for i = 1, 1000 do -- Because running a loop 1000 times per frame ensures major luls.  Also ents.GetInSphere is serverside. (which sucks major donkey balls.)

			local ent = ents.GetByIndex(i)

			if ent:IsValid() then
				local type = ent:GetClass()

				for k, v in ipairs(radar.scanfor) do
					if string.find(type,v) then
						table.insert(players,ent)
					end
				end
			end
		end

		for i, pl in ipairs(players) do
			local cx = radar.x+radar.w/2
			local cy = radar.y+radar.h/2
			local vdiff = pl:GetPos()-lpl:GetPos()
			local dummy = nil   -- Because I'm lazy.


	-- Player Check.
			if (vdiff:Length() > radar.radius) then dummy = nil else -- In soviet russia, code badly you!
				if pl:IsPlayer() then
					if ( pl:Alive() and lpl~=pl ) then
						local px = (vdiff.x/radar.radius)
						local py = (vdiff.y/radar.radius)
						local z = math.sqrt( px*px + py*py )
						local phi = math.Deg2Rad( math.Rad2Deg( math.atan2( px, py ) ) - math.Rad2Deg( math.atan2( lpl:GetAimVector().x, lpl:GetAimVector().y ) ) - 90 )
						px = math.cos(phi)*z
						py = math.sin(phi)*z
						draw.RoundedBox( 4, cx+px*radar.w/2-4, cy+py*radar.h/2-4, 8, 8, color_ascale(radar.player_color,radar.alphascale) )
						if radar.player_showname then
							draw.DrawText(pl:Name(), "Default", cx+px*radar.w/2, cy+py*radar.h/2+8, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)
						end
						if radar.player_showhealth then
							draw.RoundedBox( 0, cx+px*radar.w/2-12, cy+py*radar.h/2+20, (math.min(100,pl:Health())/100)*24, 4, Color(255,0,0,255) )
						end
						if radar.player_showammo then
							if (lpl:GetActiveWeapon().Clip1~=nil and lpl:GetActiveWeapon():Clip1() > 0) then
								draw.RoundedBox( 0, cx+px*radar.w/2-12, cy+py*radar.h/2+26, math.min(1,(lpl:GetAmmoCount(lpl:GetActiveWeapon():GetPrimaryAmmoType())/lpl:GetActiveWeapon():Clip1()))*24, 4, Color(255,200,0,255) ) --BUGGED?
							else
								draw.RoundedBox( 0, cx+px*radar.w/2-12, cy+py*radar.h/2+26, 24, 4, Color(255,200,0,255) )
							end
						end
					end
				end


	-- Ent Check.
				if ((not pl:IsPlayer()) and pl:IsValid() ) then

				    local isDangerous = false


				--Fill up the hazard mode table.
					if ( radar.hazardmode ) then
						for k,v in ipairs(radar.dangerous) do
						    if (pl:GetClass() == v) then
						        table.insert(ETable,pl)
						        isDangerous = true
							end
						end
					end
					
					local px = (vdiff.x/radar.radius)
					local py = (vdiff.y/radar.radius)
					local z = math.sqrt( px*px + py*py )
					local phi = math.Deg2Rad( math.Rad2Deg( math.atan2( px, py ) ) - math.Rad2Deg( math.atan2( lpl:GetAimVector().x, lpl:GetAimVector().y ) ) - 90 )
					px = math.cos(phi)*z
					py = math.sin(phi)*z

					if (isDangerous == false) then -- Leave this one for the hazard mode so we can give it a lovely coloured dot. Oh the frivolity.
						draw.RoundedBox( 4, cx+px*radar.w/2-4, cy+py*radar.h/2-4, 8, 8, color_ascale(radar.player_color,radar.alphascale) )
					end


					if radar.player_showname then

					--Let's do some name parsing! Whoooo... god dammit.
				
					--To add an extra name parsing thingamajobby, copy/paste one of the elseifs,
					--change the string, count the number of letters, add one, and use that as the last number.

						local nametag = ""
						if string.find(pl:GetClass(),"blastfungus") then nametag = "" -- There will usually be so many of these that adding names will look messy.
						elseif string.find(pl:GetClass(),"npc_") then nametag = string.sub(pl:GetClass(),5)
						elseif string.find(pl:GetClass(),"sent_") then nametag = string.sub(pl:GetClass(),6)
						elseif string.find(pl:GetClass(),"prop_vehicle_") then nametag = string.sub(pl:GetClass(),14)
						else nametag = pl:GetClass()
						end

						local nametable = string.Explode("_",nametag)
						nametag = table.concat(nametable," ")
						local nametag1 = string.sub(nametag,0,1)
						local nametag2 = string.sub(nametag,2)
						nametag1 = string.upper(nametag1)
						nametag = nametag1..nametag2

							draw.DrawText(nametag, "Default", cx+px*radar.w/2, cy+py*radar.h/2+8, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)

					end
				end
   			end
	 	end
	 	

   -- Hazard Mode.
   -- This is where things get hacky.  Well, more hacky.
   
   		local count = table.Count(ETable)
   		
   		if ( count > 0 ) then 	-- Oooooh shit.
   		for k,pl in ipairs(ETable) do
   			local cx = radar.x+radar.w/2
			local cy = radar.y+radar.h/2
			local vdiff = pl:GetPos()-lpl:GetPos()
			
   			local px = (vdiff.x/radar.radius)
			local py = (vdiff.y/radar.radius)
			local z = math.sqrt( px*px + py*py )
			local phi = math.Deg2Rad( math.Rad2Deg( math.atan2( px, py ) ) - math.Rad2Deg( math.atan2( lpl:GetAimVector().x, lpl:GetAimVector().y ) ) - 90 )
			px = math.cos(phi)*z
			py = math.sin(phi)*z
			
			draw.RoundedBox( 8, (cx+px*radar.w/2-8), (cy+py*radar.h/2-8), 16, 16, color_ascale(radar.dangerblipcolour,radar.alphascale) ) -- M-M-MONSTER DOT.
		end
			
			radar.bgcolor = Color(255,255,255,0)
			radar.fgcolor = Color(60,60,60,100)
			
			PulseRadar = true
			
			
 			
		end
		
		gspHUD_Radar_pulse(PulseRadar)
		
	end
end


function gspHUD_Radar_pulse(var)

	if ( var ) then

	-- Let's figure out the colour shift.
		local diff = {}
		diff.r = radar.dangercolour.r - radar.bgcolorbak.r
		diff.g = radar.dangercolour.g - radar.bgcolorbak.g
		diff.b = radar.dangercolour.b - radar.bgcolorbak.b

	
	-- Now let's throw sine at it and see what happens.	
		radar.bgcolor = Color( ((0.5*math.sin(CurTime()*2)+0.51)*diff.r), ((0.5*math.sin(CurTime()*2)+0.51)*diff.g), ((0.5*math.sin(CurTime()*2)+0.51)*diff.b), 255 ) -- 0.51... lol.
	

	-- Contrasting the crosshair thingy.
		radar.fgcolor = Color( 255-radar.bgcolor.r, 255-radar.bgcolor.g, 255-radar.bgcolor.b, 255 )
	
	
	-- Greying out the 'passive' blips.
		radar.player_color = Color(160,160,160,100)
	
	-- DEBUGGING WHAT
--		draw.DrawText(radar.bgcolor.r, "Default", ScrW() - 400, 300, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)
--		draw.DrawText(radar.bgcolor.g, "Default", ScrW() - 400, 340, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)
--		draw.DrawText(radar.bgcolor.b, "Default", ScrW() - 400, 380, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)
		
--		draw.DrawText(diff.r, "Default", ScrW() - 300, 300, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)
--		draw.DrawText(diff.g, "Default", ScrW() - 300, 340, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)
--		draw.DrawText(diff.b, "Default", ScrW() - 300, 380, color_ascale(radar.player_fontcolor,radar.alphascale), TEXT_ALIGN_CENTER)
	
	else
		if ( radar.bgcolor ~= radar.bgcolorbak ) then

   		 	radar.bgcolor = radar.bgcolorbak
			radar.fgcolor = radar.fgcolorbak
			radar.player_color = radar.player_colorbak
	
		end
	
	end
end


function gspHUD_Radar_cc_radarvar_autocomplete ( command, args )
	argv = string.Explode(" ",string.sub(args,2))
	--Msg("Autocomplete args: '"..string.sub(args,2).."' argc: "..table.getn(argv).."\n")
	if (table.getn(argv)>1) then if (radar[argv[1]]~=nil) then return {command.." "..argv[1].." "..radar[argv[1]]} else return {} end end
	local ret = {}
	for k,v in pairs(radar) do
		table.insert(ret,command.." "..k)
	end
	return ret
end

function gspHUD_Radar_cc_radarvar ( pl, command, args )
	--Msg(type(args).."\n")
	--argv = string.Explode(" ",string.sub(args,2))
	if ( table.getn(args) < 1 ) then Msg(HUD_PRINTCONSOLE,"No var given!\n"); return end
	if ( radar[args[1]] == nil ) then Msg(HUD_PRINTCONSOLE,"Unknown radar var '"..args[1].."'!\n"); return end
	if ( table.getn(args) < 2 ) then Msg(HUD_PRINTCONSOLE,"No value given!\n"); return end
	radar[args[1]] = tonumber(args[2])
end

concommand.Add( "gsphud_radarvar", gspHUD_Radar_cc_radarvar, gspHUD_Radar_cc_radarvar_autocomplete )


hook.Add( "HUDPaint", "gspHUD_DrawRadar", gspHUD_DrawRadar )

